-- | This module defines the 'Cfg' type, which is just a wrapper
--   around all of the configuration options we accept on the command
--   line. We thread this throughout the rest of the program.
module Configuration (
  Cfg(..)
)
where

data Cfg = Cfg { consumer_key :: String,
                 consumer_secret :: String,
                 access_token :: String,
                 access_secret :: String,
                 heartbeat :: Int,
                 ignore_replies :: Bool,
                 ignore_retweets :: Bool,
                 sendmail_path :: String,
                 from_address :: Maybe String,
                 to_address :: Maybe String,
                 verbose :: Bool }
